#include "compito.h"

Cinema::Cinema(int m1, int n1, const char *nome1){
   // sanifico l'input:
   if(m1<=0 || m1>26)
      m1 = 26;
   if(n1<=0 || n1>9)
      n1 = 9;
   m = m1;
   n = n1;
   if (strlen(nome1) > MAXCHAR)
      strcpy(nome, "Default");
   else
      strcpy(nome, nome1);

   // imposto tutti i posti a liberi:
   for (int i = 0; i < m; i++)
      for(int j = 0; j < n; j++)
         p[i][j] = false;
}

bool Cinema::prenota(char l, int j){
   // costruisco gli indici a base 0 di fila e colonna:
   l -= 'A';
   j -= 1;
   // gestisco input non valido:
   if (l<0 || l>=m || j<0 || j>=n)
      return false;
   // prenoto il posto se non era gia' prenotato:
   if (p[l][j])
      return false;
   p[l][j] = true;
   return true;
}

bool Cinema::cancella(char l, int j){
   // costruisco gli indici a base 0 di fila e colonna:
   l -= 'A';
   j -= 1;
   // gestisco input non valido:
   if (l<0 || l>=m || j<0 || j>=n)
      return false;
   // cancello la prenotazione del posto se era prenotato:
   if (!p[l][j])
      return false;
   p[l][j] = false;
   return true;
}

int Cinema::quantiLiberi(){ // OPPURE: int Cinema::quantiLiberi()const{
   int quanti = 0;
   for (int i=0; i<m; i++)
      for (int j=0; j<n; j++)
         if (!p[i][j]) 
            quanti++;
   return quanti;
}

void Cinema::stampa(){ // OPPURE: void Cinema::stampa()const{
   cout << "Nome del cinema: " << nome << endl << ' ';
   for (int j = 1; j <= n; j++)
      cout << j;
   cout << endl;
   for (int i = 0; i < m; i++){
      cout << char('A' + i);
      for (int j = 0; j < n; j++){
         if (p[i][j])
            cout << "*";
         else
            cout << " ";
      }
      cout << endl;
   }
}

bool Cinema::prenotaAdiacenti(int k){
   // gestisco input non valido:
   if (k<0 || k>n)
      return false;

   for (int i = 0; i < m; i++){
      for (int j = 0; j <= n-k; j++){
         // controllo se a partire dalla fila i posto j ci sono k posti liberi adiacenti:
         bool kliberi = true;
         for (int v = 0; v < k; v++){
            if (p[i][j+v]){
               // non ci sono k posti liberi adiacenti.
               // continuo a cercare dal posto successivo se c'e', o dalla fila successiva se c'e':
               // OTTIMIZZAZIONE: j += v; // salto i posti che so gia' essere occupati
               kliberi = false;
               break;
            }
         }
         if (kliberi){
            // occupo i k posti liberi adiacenti trovati:
            for (int v = 0; v < k; v++)
               p[i][j+v] = true;
            return true;
         }
      }
   }
   return false;
}
