// Versione ottimizzata per risparmiare memoria.
// Utilizzo un vettore dinamico anziche' una matrice statica, 
// cosi' da allocare il numero giusto di posti al momento 
// della costruzione.

#include <iostream>
#include <cstring>
using namespace std;

const int MAXCHAR = 30;
const int MAXROWS = 26;
const int MAXCOLS = 9;

class Cinema{
   bool *p;
   int m;
   int n;
   char nome[MAXCHAR+1];

public:
   Cinema(int,int,const char*);
   ~Cinema();
   bool prenota(char, int);
   bool cancella(char, int);
   void stampa(); // O MEGLIO: void stampa()const;

   int quantiLiberi(); // O MEGLIO: int quantiLiberi()const;
   bool prenotaAdiacenti(int);
};
